<?php
/*
Plugin Name: Premise to Post Affiliate Pro
Plugin URI: 
Description: Integrates Premise with Post Affiliate Pro (and Post Affiliate Network) to track order details and help you track affiliate commissions. It passes order details and is also capable of passing values of customer name, email address and purchased products.
Version: 1.0.1
Author: Martin Pullmann
Author URI: http://www.qualityunit.com/
License: GPLv2 or later
*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

class PremisePostAffiliatePro {

	private $options;
	private $tracker = '<script type="text/javascript"><!--
      document.write(unescape("%3Cscript id=\'pap_x2s6df8d\' src=\'" + (("https:" == document.location.protocol) ? "https://" : "http://") +
      "'.$this->maintainSaleUrl($this->options['url']).'scripts/trackjs.js\' type=\'text/javascript\'%3E%3C/script%3E"));//-->
      </script>'."\n".
      "<script type=\"text/javascript\"><!--
      PostAffTracker.setAccountId('default1');
      try {
      PostAffTracker.track();
      } catch (err) { }
      //-->
      </script>";

	function __construct() {
		$this->options = (array) get_option('premise-postaffiliatepro-settings');

		if (isset($this->options['enabled']) && $this->options['enabled']) {
			add_action('premise_membership_create_order', array($this, 'get_order_data'), 10, 3);
			add_action('premise_checkout_complete_after', array($this, 'prepareTrack'), 10);
			add_action('wp_footer', 'track');
		}

		add_action('init', array($this, 'admin_init'));
	}

	function admin_init() {
		if (is_admin())
			require dirname(__FILE__) .'/admin.php';
	}

	function get_order_data($member_id, $order_details, $renewal) {
		$this->order_data = array(
			'orderID' => $order_details['_acp_order_time'],
			'total' => $order_details['_acp_order_price'] ? $order_details['_acp_order_price'] : 0,
		);
		
		if ($this->order_data['total'] < 0)
      $this->order_data['total'] = 0;

		$this->product = get_post($order_details['_acp_order_product_id']);
		$this->customer = get_userdata($member_id);
	}
	
	functin maintainSaleUrl($url) {
    $url = str_replace('https://','',$url);
    $url = str_replace('http://','',$url);
    $url = trailingslashit($url);
    return $url;
  }

	function prepareTrack() {
    $this->tracker = '<script type="text/javascript"><!--
      document.write(unescape("%3Cscript id=\'pap_x2s6df8d\' src=\'" + (("https:" == document.location.protocol) ? "https://" : "http://") +
      "'.$this->maintainSaleUrl($this->options['url']).'scripts/trackjs.js\' type=\'text/javascript\'%3E%3C/script%3E"));//-->
      </script>'."\n";
    $this->tracker .= '<script type="text/javascript"><!--'."\n";
    $this->tracker .= "PostAffTracker.setAccountId('".$this->options['accountID']."');\n";
		$this->tracker .= "sale.setTotalCost('".$this->order_data['total']."');\n";
		$this->tracker .= "sale.setOrderID('".$this->order_data['orderID']."');\n";
		
		if (isset($this->options['product_name']) && !empty($this->options['product_name']))
      $this->tracker .= "sale.setProductID('".$this->product->post_title."');\n";

		if (isset($this->options['product_id']) && !empty($this->options['product_id']))
			$this->tracker .= "sale.setProductID('".$var = $this->product->ID."');\n";

		for ($i = 1; $i <= 4; $i++) {
      if (! isset($this->options['edata_' . $i]) || empty($this->options['edata_' . $i]))
				continue;

			switch ($this->options['edata_' . $i]) {
				case 'customer_name':
					$this->tracker .= "sale.setData".$i."('".$this->customer->user_firstname . ' ' . $this->customer->user_lastname."');\n";
					break;
				case 'customer_username':
          $this->tracker .= "sale.setData".$i."('".$this->customer->user_login."');\n";
					break;
				case 'customer_email':
					$this->tracker .= "sale.setData".$i."('".$this->customer->user_email."');\n";
					break;
				case 'site_name':
					$this->tracker .= "sale.setData".$i."('".get_bloginfo('name')."');\n";
					break;
				default:
					$value = apply_filters('premise_postaffiliatepro_optional_variable_value', $var, $this->options['edata_' . $i]);
					$this->tracker .= "sale.setData".$i."('".$value."');\n";
					break;
			}
		}

		$this->tracker .= "</script>\n";
	}
	
	function track() {
    echo "<!-- Post Affiliate Pro integration snippet -->";
    echo $this->tracker;
    echo "<!-- /Post Affiliate Pro integration snippet -->";
  }
}

new PremisePostAffiliatePro;
